VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MsComCtl.ocx"
Begin VB.UserControl AutoFillImageCombo 
   ClientHeight    =   2250
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   5820
   ScaleHeight     =   2250
   ScaleWidth      =   5820
   ToolboxBitmap   =   "AutoFillCombo.ctx":0000
   Begin MSComctlLib.ImageCombo cboImageCombo 
      Height          =   330
      Left            =   90
      TabIndex        =   0
      Top             =   150
      Width           =   4995
      _ExtentX        =   8811
      _ExtentY        =   582
      _Version        =   393216
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
   End
End
Attribute VB_Name = "AutoFillImageCombo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Public ComboProperties As ImageCombo
Attribute ComboProperties.VB_VarHelpID = -1
Private booLimitToList As Boolean
Event BeforeKeyPress()
Event AfterKeyPress()
Event AfterUpdate()

Property Get LimitToList() As Boolean
    LimitToList = booLimitToList
End Property

Property Let LimitToList(booLimit As Boolean)
    booLimitToList = booLimit
End Property

Private Sub cboImageCombo_Click()

    RaiseEvent AfterUpdate

End Sub

Private Sub cboImageCombo_KeyDown(KeyCode As Integer, Shift As Integer)
    
RaiseEvent BeforeKeyPress

    Select Case KeyCode
        Case 65 - 90        'a-z and A-Z
            UserControl.cboImageCombo.Locked = True
        Case 48 - 57        '0-9
            UserControl.cboImageCombo.Locked = True
        Case 188            ',
            UserControl.cboImageCombo.Locked = True
        Case 190            '.
            UserControl.cboImageCombo.Locked = True
        Case 223            '`
            UserControl.cboImageCombo.Locked = True
        Case 220            '\
            UserControl.cboImageCombo.Locked = True
    End Select

End Sub

Private Sub cboImageCombo_KeyPress(KeyAscii As Integer)
Dim strToPass As String

    Select Case KeyAscii
        Case 8          'Backspace
            UserControl.cboImageCombo.Locked = False
            Exit Sub
        Case 13         'Enter
            If UserControl.cboImageCombo.Text = "" Then
                KeyAscii = 0
                Exit Sub
            End If
            strToPass = UserControl.cboImageCombo.Text
        Case Else
            strToPass = Left(UserControl.cboImageCombo.Text, UserControl.cboImageCombo.SelStart) & Chr(KeyAscii)
    End Select
    
    If WasKeyUsed(strToPass) = False Then   'If the key didn't exist in the list
        If LimitToList = False Then
            Exit Sub
        End If
    End If
    
    If KeyAscii = 13 Then
        UserControl.cboImageCombo.SelStart = 0
        UserControl.cboImageCombo.SelLength = Len(UserControl.cboImageCombo.Text)
    Else
        KeyAscii = 0
    End If
    
RaiseEvent AfterKeyPress

End Sub

Private Sub UserControl_Initialize()
    Set ComboProperties = UserControl.cboImageCombo
    LimitToList = True
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    booLimitToList = PropBag.ReadProperty("LimitToList", True)
    
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("LimitToList", booLimitToList, True)

End Sub

Private Sub UserControl_Resize()

    With UserControl.cboImageCombo
        .Top = 0
        .Left = 0
        .Width = UserControl.Width
        UserControl.Height = .Height
    End With

End Sub

Private Function WasKeyUsed(strTypedPrevious As String) As Boolean
Dim lngRow As Long
Dim intLen As Integer
Dim strToAdd As String
    
    intLen = Len(strTypedPrevious)
    
    For lngRow = 1 To UserControl.cboImageCombo.ComboItems.Count
        
        If Left(UCase$(UserControl.cboImageCombo.ComboItems.Item(lngRow).Text), intLen) = UCase$(strTypedPrevious) Then
            strToAdd = Mid(UserControl.cboImageCombo.ComboItems.Item(lngRow).Text, intLen + 1)
            With UserControl.cboImageCombo
                .Locked = False
                .Text = strTypedPrevious & strToAdd
                If Not .SelectedItem Is Nothing Then
                    If .SelectedItem = .ComboItems(lngRow) Then
                    Else
                        RaiseEvent AfterUpdate
                    End If
                Else
                    RaiseEvent AfterUpdate
                End If
                Set .SelectedItem = .ComboItems(lngRow)
                .SelLength = Len(strToAdd) + Len(strTypedPrevious)
                .SelStart = intLen
                
            End With
            WasKeyUsed = True
            Exit Function
        End If
        
    Next lngRow
    
    
End Function
